using System.Collections;
using UnityEngine;

public class PlayerController : MonoBehaviour
{
    public float moveSpeed = 5f;  // ̵ ӵ
    public float dashDistance = 3f;  //  Ÿ
    public float dashCooldown = 1f;  //  Ÿ
    public float maxSpeed = 8f;   // ִ ӵ (2~3  ִ ӵ )
    public float accelerationTime = 2f; // 2  
    private float moveTime = 0f;  // ̵ ð
    public float dashTime = 0.5f;
    private bool canDash = true;  //   
    private Vector2 moveDirection = Vector2.zero;  //  ̵ 
    private bool isWalking = false;  // ̵  
    private float dashValue;
    Animator animator;
    SpriteRenderer spriteRenderer;

    private float idleState = 0f; // 0: , 0.333: , 0.666: , 1: Ʒ

    void Start()
    {
        spriteRenderer = GetComponentInChildren<SpriteRenderer>();
        animator = GetComponentInChildren<Animator>();

        // Ű ̺Ʈ Ʈ  ȸ ó 
        PlayManager.Instance.keySdown += () => SetMovement(Vector2.down, 1f / 3f);  // Ʒ
        PlayManager.Instance.keyWdown += () => SetMovement(Vector2.up, 2f / 3f);   // 
        PlayManager.Instance.keyAdown += () => SetMovement(Vector2.left, 1f);  // 
        PlayManager.Instance.keyDdown += () => SetMovement(Vector2.right, 1f); // 

        //   
        PlayManager.Instance.keySpace += Dash;
    }

    void Update()
    {
        HandleMovement(); // ̵ ó
    }

    // ̵ ó
    void HandleMovement()
    {
        if (!canDash) return;
        moveDirection = Vector2.zero;  //   ʱȭ

        // Ű ¸  Ȯϰ  
        if (Input.GetKey(KeyCode.A)) moveDirection += Vector2.left;
        if (Input.GetKey(KeyCode.D)) moveDirection += Vector2.right;
        if (Input.GetKey(KeyCode.W)) moveDirection += Vector2.up;
        if (Input.GetKey(KeyCode.S)) moveDirection += Vector2.down;

        // ̵  Ǻ
        isWalking = moveDirection != Vector2.zero;
        animator.SetBool("isWalking", isWalking);

        // ̵    ̵
        if (isWalking)
        {
            moveTime += Time.deltaTime;
            // 2 ̻ ̵ϸ  ӵ maxSpeed 
            float currentSpeed = HandleAcceleration();

            transform.position += (Vector3)(moveDirection.normalized * currentSpeed * Time.deltaTime);
            // A Ǵ D  ¶ Side ִϸ̼ 켱 
            if (moveDirection.x != 0)
            {
                animator.SetFloat("moveX", 1);  //  Side ִϸ̼
                animator.SetFloat("moveY", 0);  // /Ʒ 
            }
            else
            {
                animator.SetFloat("moveX", 0);
                animator.SetFloat("moveY", moveDirection.y);
            }

            // ȸ ó
            if (Mathf.Abs(moveDirection.x) > 0)
            {
                if (moveDirection.x < 0 && transform.GetChild(0).localEulerAngles.y != 180)
                {
                    transform.GetChild(0).localEulerAngles = new Vector3(0, 180, 0);
                }
                else if (moveDirection.x > 0 && transform.GetChild(0).localEulerAngles.y != 0)
                {
                    transform.GetChild(0).localEulerAngles = new Vector3(0, 0, 0);
                }
            }
        }
        else
        {
            // ̵  Idle ¸ 
            moveTime = 0f;
            animator.SetFloat("moveX", 0);
            animator.SetFloat("moveY", 0);
            animator.SetFloat("idleState", idleState);
        }

    }
    float HandleAcceleration()
    {
        if (isWalking)
        {
            moveTime += Time.deltaTime;
            if (moveTime >= accelerationTime)
            {
                return maxSpeed; // 2 ̻ ̵  
            }
        }
        return moveSpeed; // ⺻ ӵ
    }
    //  ó
    void Dash()
    {
        if (canDash)
        {
            canDash = false;
            isWalking = false;
            animator.SetTrigger("DodgeTrigger");

            StartCoroutine(DashCoroutine()); //  
        }
    }

    IEnumerator DashCoroutine()
    {
        Vector3 startPosition = transform.position;
        Vector3 targetPosition = startPosition + (Vector3)(moveDirection.normalized * dashDistance);
        float elapsedTime = 0f;

        while (elapsedTime < dashTime)
        {
            transform.position = Vector3.Lerp(startPosition, targetPosition, elapsedTime / dashTime);
            elapsedTime += Time.deltaTime;
            yield return null;
        }

        transform.position = targetPosition;
        canDash = true;
    }
    // ̵  Ʈ, ȸ ó
    void SetMovement(Vector2 direction, float idleStateValue)
    {
        moveDirection = direction;
        idleState = idleStateValue;
    }
}
